# Copyright (C) 1998 - Martin Strauss - under terms of GPL
proc NewFile {} {
 global FocusEditor
 global FilenameArray
 global EDITORNUMMER
 global etcpath
 set E [EDITOR]
 $E.te.edit1 delete 1.0 end
 set FilenameArray($E) ""
 wm title $E "no name $EDITORNUMMER"
 if [file exists "$etcpath/default.tex"] then {
  set f [open "$etcpath/default.tex" r]
  set x [read $f]
  $E.te.edit1 insert 1.0 $x
  set t [close $f]
 } else {
  $E.te.edit1 insert end "\\documentclass\[12pt,a4paper\]{report}\n"
#  $E.te.edit1 insert end "\\usepackage\[german\]{babel}\n"
#  $E.te.edit1 insert end "\\usepackage{umlaut}\n"
  $E.te.edit1 insert end "\\begin{document}\n\n"
  $E.te.edit1 insert end "\\end{document}\n"
 }
 Syntax $E.te.edit1 1.0 end
 set ksp [$E.te.edit1 search "\\begin{document}" 1.0]
 $E.te.edit1 mark set insert "$ksp + 1 lines"
 after 250 "event generate $E.te.edit1 <<Position_tail>> -when tail"
}
proc NewFileArg {} {
 global FocusEditor
 global FilenameArray
 global EDITORNUMMER
 global etcpath
 set E [EDITOR]
 $E.te.edit1 delete 1.0 end
 set FilenameArray($E) ""
 wm title $E "no name $EDITORNUMMER"
 if [file exists "$etcpath/default.tex"] then {
  set f [open "$etcpath/default.tex" r]
  set x [read $f]
  $E.te.edit1 insert 1.0 $x
  set t [close $f]
 } else {
  $E.te.edit1 insert end "\\documentclass\[12pt,a4paper\]{report}\n"
#  $E.te.edit1 insert end "\\usepackage\[german\]{babel}\n"
#  $E.te.edit1 insert end "\\usepackage{umlaut}\n"
  $E.te.edit1 insert end "\\begin{document}\n\n"
  $E.te.edit1 insert end "\\end{document}\n"
 }
 Syntax $E.te.edit1 1.0 end
 set ksp [$E.te.edit1 search "\\begin{document}" 1.0]
 $E.te.edit1 mark set insert "$ksp + 1 lines"
 after 250 "event generate $E.te.edit1 <<Position_tail>> -when tail"
}


proc LoadFile {} {
 global FilenameArray ModifiedArray directory
 set types {
    {{latex Files} {.tex} }
    {{plain Text} {.txt}}
    {{All Files}        *}
 }
 set filename [tk_getOpenFile -filetypes $types -initialdir $directory]
 LoadFileArg $filename
}

proc LoadFileArg {filename} {
 global FilenameArray ModifiedArray directory
 if {[file exists $filename]} then {
  set directory [file dirname $filename]
  set E [EDITOR]
  set f [open $filename r]
  set x [read $f]
  $E.te.edit1 insert 1.0 $x
  set t [close $f]
  #Set global filename
  set FilenameArray($E) $filename
  wm title $E "$filename"
  Syntax $E.te.edit1 1.0 end
  event generate $E.te.edit1 <<Modified>>
  after 500 "event generate $E.te.edit1 <<Position_tail>> -when tail"
  after 500 "focus $E.te.edit1"
 }
}

proc AppendFile {E} {
 global directory
 set types {
    {{latex Files} {.tex} }
    {{plain Text} {.txt}}
    {{All Files}        *}
 }
 set filename [tk_getOpenFile -filetypes $types -initialdir $directory]
 if {$filename != ""} then {
  set directory [file dirname $filename]
  set f [open $filename r]
  set x [read $f]
  #Append file at end of text
  $E.te.edit1 insert insert $x
  #Close source file
  set t [close $f]
  Syntax $E.te.edit1 1.0 end
  event generate $E.te.edit1 <<Modified>>
}}

proc SaveFile {E} {
 global FilenameArray ModifiedArray
 if {$FilenameArray($E)!= ""} then {
  set f [open $FilenameArray($E) w]
  #Get text to save
  set x [$E.te.edit1 get 1.0 end]
  #Save it
  puts $f $x
  #and close file
  set t [close $f]
  set ModifiedArray($E.te.edit1) 0
  set ModifiedArrayl($E.te.edit1) [string length $x]
 } else {SaveAsFile $E}
}

proc SaveAsFile {E} {
 global FilenameArray ModifiedArray directory
 set types {
    {{latex Files} {.tex} }
    {{plain Text} {.txt}}
    {{All Files}        *}
 }
 set filename [tk_getSaveFile -filetypes $types -initialfile $FilenameArray($E) -defaultextension ".tex" -initialdir $directory]
 if {$filename != ""} then {
  set directory [file dirname $filename]
  set f [open $filename w]
  #Get text to save
  set x [$E.te.edit1 get 1.0 end]
  #Save it
  puts $f $x
  #and close file
  set t [close $f]
  set FilenameArray($E) $filename
  wm title $E "$FilenameArray($E)"
  set ModifiedArray($E.te.edit1) 0
}}


